#include <stdio.h>
#include "fftw3.h"

//	define FFTW_SINGLE for float/SSE operation

#ifdef FFTW_SINGLE
#ifdef HAVE_SSE
#define MODE	"float/SSE"
#else
#define MODE	"float"
#endif
#else
#ifdef HAVE_SSE2
#define MODE	"double/SSE2"
#else
#define MODE	"double"
#endif
#endif

#define N	1024

#ifdef FFTW_SINGLE

void main(void)
{
    fftwf_complex *in, *out;
    fftwf_plan p;

	printf("fftw-3.0.1 for Win32, mode: %s, sizeof(fftwf_complex) = %d\n", MODE, sizeof(fftwf_complex));
    in = fftwf_malloc(sizeof(fftwf_complex) * N);
    out = fftwf_malloc(sizeof(fftwf_complex) * N);
    p = fftwf_plan_dft_1d(N, in, out, FFTW_FORWARD, FFTW_ESTIMATE);
    fftwf_execute(p); /* repeat as needed */
    fftwf_destroy_plan(p);
    fftwf_free(in); fftwf_free(out);
}

#else

void main(void)
{
    fftw_complex *in, *out;
    fftw_plan p;

	printf("fftw-3.0.1 for Win32, mode: %s, sizeof(fftw_complex) = %d\n", MODE, sizeof(fftw_complex));
    in = fftw_malloc(sizeof(fftw_complex) * N);
    out = fftw_malloc(sizeof(fftw_complex) * N);
    p = fftw_plan_dft_1d(N, in, out, FFTW_FORWARD, FFTW_ESTIMATE);
    fftw_execute(p); /* repeat as needed */
    fftw_destroy_plan(p);
    fftw_free(in); fftw_free(out);
}

#endif
